libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;



**********************************************************************************************************************
*                                    		Download returns with and without dividends
********************************************************************************************************************* ; 


%let wrds=wrds-cloud.wharton.upenn.edu 4016;
options comamid=TCP remote=WRDS;
signon username=_prompt_;


rsubmit;
data msf ; 
merge crsp.msf(keep = permno permco  ret retx date prc  cfacshr shrout) crsp.mseall(keep = permno date  shrcd exchcd siccd);
by permno date ; 
keep permno permco date ret  shrcd retx  prc shares adj exchcd siccd me; 
shares = shrout /1000 ; 
adj = cfacshr ; 
drop cfacshr ; 
prc = abs(prc); 
me = abs(prc)*shares;
format me shares 9.2 ; 
run ; 


data dret (keep = permno dlpdt dlstcd dlret dlretx) ; 
	set crsp.mseall ; 
	where dlstcd is not missing and dlpdt; 

	* ret to -30 % if performence-related and missing  ; 
	if missing(dlret) and dlstcd = 500 then dlret = -.3 ; 
	if missing(dlret) and (520<= dlstcd <= 584) then dlret = -.3 ;
	if missing(dlretx) and dlstcd = 500 then dlretx = -.3 ; 
	if missing(dlretx) and (520<= dlstcd <= 584) then dlretx = -.3 ;

	* set to zero otherwise ; 
	if missing(dlret) then dlret = 0 ; 	  
	if missing(dlretx) then dlretx = 0 ; 	  
run ; 


proc sql ; 
create table dret as select distinct
permno , b.date , dlret, dlretx from dret a , crsp.msi b
where intck('month',dlpdt,b.date) = 0 order by permno , date ; 

proc sort nodupkey ; by permno date ; run ; 

data msf ; 
merge msf dret ; 
by permno date ;
if dlret ^=. then ret = dlret ; 
if dlretx ^=. then retx = dlretx ; 
drop dlret ; 
run ;


proc download data=msf out=ind.dividends;
run;
endrsubmit;


proc sql ; 
create table msf as select distinct
permno , date , ret , retx, me , prc , shares , adj ,  EXCHCD as ex   format  9.2
from ind.dividends order by permno , date ; 

data msf ; set msf;
vid = compress("USA"||PERMNO);
run;

proc sql;
create table ind.dividends as select distinct
a.*, b.ret format 11.6, b.retx format 11.6, b.ret-b.retx as div format 11.6
from rsch.msf(drop = ret) a,
msf b
where a.date=b.date and a.vid=b.vid;


proc delete data = _all_; run;


**********************************************************************************************************************
*                                    					Download LTG
********************************************************************************************************************* ; 




%let wrds=wrds-cloud.wharton.upenn.edu 4016;
options comamid=TCP remote=WRDS;
signon username=_prompt_;




rsubmit;



proc sql ; 
create table usa as select distinct
permno , "USA" as ex format $3. , a.*
from ibes.Statsumu_epsus a , crsp.stocknames b
where a.cusip = b.cusip and st_date<= STATPERS<= end_date and USFIRM = 1 and MEASURE = 'EPS'
and FISCALP = 'LTG' ; 


 

proc sort nodupkey ; by permno statpers ; run ; 



proc sql ; 
create table can as select distinct
compress(gvkey||"__"||iid) as vid ,  excntry  as ex,  a.*
from ibes.Statsumu_epsint a , comp.security b
where a.ticker = b.ibtic  and USFIRM = 0 and excntry = 'CAN'  and USFIRM = 0 and MEASURE = 'EPS' and FISCALP = 'LTG' 
and ibtic is not missing and a.ticker is not missing 
order by vid , statpers ; 

proc sort  nodupkey ; by vid   statpers ; run ; 


proc sql ; 
create table int as select distinct
compress(gvkey||"__"||iid) as vid ,  excntry  as ex,  a.* 
from ibes.Statsumu_epsint  a , comp.g_security b
where a.ticker = b.ibtic  and USFIRM = 0 and excntry not in ('USA','CAN')  and USFIRM = 0 and MEASURE = 'EPS' and FISCALP = 'LTG' 
and ibtic is not missing and a.ticker is not missing 
order by vid , statpers ; 

proc sort  nodupkey ; by vid   statpers ; run ; 


data usa ; set usa ; 
vid = compress("USA"||permno); 
drop permno ; 
run ; 

proc sql ; 
create table usa as select distinct vid , * from usa ; 


proc append data = can base =USA force; run;
proc append data = int base =USA force; run;

proc download data=usa out=ind.expectations;
run;
endrsubmit;
