libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;




data chars; set ind.raws; run;

proc sort data = chars; by ex rdate; run;

proc rank data = chars out = chars2 PERCENT;
by ex rdate;
var bm op inv beta pay me ; run;

data chars2; set chars2; if bm = . then bm = 50; if op = . then op = 50 ; if beta = . then beta = 50 ; if pay = . then pay = 50. ; if me = . then me = 50; run;

data ind.characteristics; set chars2;run;

proc delete data = _all_; run;


data raws; set ind.raws; mep = me;
where ex = "USA" and year(rdate) ge 1952 and month(rdate)=6;
proc sort; by ex rdate; run;

proc rank data = raws out = temp.raws PERCENT;
by ex rdate;
var me ; run;


data temp.xfa;
set rsch.xfa;
by vid rdate;
me_fye_s = me_fye/sharesoutstanding;

if sharesoutstanding = 0 then me_fye_s = .;

lag_me_fye_s = lag(me_fye_s);

if first.vid then lag_me_fye_s = .;

ep = (netincome/sharesoutstanding)/lag_me_fye_s;

if first.vid then ep = . ;
if lag_me_fye_s < 0 then ep = . ;

run;


proc delete data = _all_; run;


**********************************************************************************
									PORTFOLIOS
**********************************************************************************;




%p10_divs(temp.raws(where = (month(rdate)=6)), BM,   k=180); 	    data temp.d_bm  ; set p10_divs_bm  ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_divs(temp.raws(where = (month(rdate)=6)), op,   k=180);  	    data temp.d_op  ; set p10_divs_op  ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_divs(temp.raws(where = (month(rdate)=6)), inv,  k=180);	    data temp.d_inv ; set p10_divs_inv ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_divs(temp.raws(where = (month(rdate)=6)), beta, k=180);     	data temp.d_beta; set p10_divs_beta; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_divs(temp.raws(where = (month(rdate)=6)), pay,  k=180);   		data temp.d_pay ; set p10_divs_pay ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;


%p10_earnings(temp.raws(where = (month(rdate)=6)), BM,   k=180); 	  data temp.e_bm  ; set p10_earnings_bm  ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_earnings(temp.raws(where = (month(rdate)=6)), op,   k=180);	  data temp.e_op  ; set p10_earnings_op  ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_earnings(temp.raws(where = (month(rdate)=6)), inv,  k=180);	  data temp.e_inv ; set p10_earnings_inv ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_earnings(temp.raws(where = (month(rdate)=6)), beta, k=180);      data temp.e_beta; set p10_earnings_beta; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
%p10_earnings(temp.raws(where = (month(rdate)=6)), pay,  k=180);      data temp.e_pay ; set p10_earnings_pay ; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;


proc delete data = _all_; run;


%macro dividends(xx = );

data p10; set temp.d_&xx; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;

data p10; set p10(where = (I > 0 and month(refresh_date)=6 and year(rdate)> 1963));
retain P 100;
by ind refresh_date;
if first.refresh_date then P=100;
P=P*(1+retx);
run;

data p10 ; set p10;
by ind refresh_date;
div = lag(P)*(ret-retx);
if first.refresh_date then div = 100*(ret-retx);
run;

data p10;  set p10; where year(refresh_date) le 2005; 

I=intck('month', refresh_date, date); year= 0;
if I > 0 then year = 1;
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;

proc sql; create table sums as select distinct
ind, refresh_date, year, sum(div) as div format 11.6
from p10 group by ind, refresh_date, year;

%p10(temp.raws(where = (month(rdate)=6 and year(rdate) > 1963)), &xx);

proc sql; create table chars as select distinct
a.ex, a.ind, a.refresh_date, a.rdate, a.date, -sum(w*b.beta) as low_beta, sum(w*b.bm) as bm, 
sum(w*b.op) as op, -sum(w*b.inv) as low_inv, sum(w*b.pay) as pay, mean(me) as me, sum(w*1) as eg_1, sum(w*1) as eg_2
from p10_w_&xx(where =  (1963 le year(date) le 2005))  a, ind.characteristics b where a.ex=b.ex and a.vid=b.vid and a.rdate=b.rdate group by a.ex, a.ind, a.rdate;



proc sql; create table temp.p10_new_&xx as select distinct
a.ind, a.refresh_date,  a.div as div1, b.div as div2, (b.div/a.div)**(1/14)-1 as growth, c.*
from sums(where = (year = 1)) a, sums(where = (year = 15)) b, chars c
where a.refresh_date=b.refresh_date=c.refresh_date and a.ind=b.ind=c.ind; 

%mend;


%macro earnings(xx = );

data p10; set temp.e_&xx; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;

data p10; set p10(where = (I > -24 and month(refresh_date)=6 and year(rdate)> 1952));
retain P 100;
by ind refresh_date;
if first.refresh_date then P=100;
P=P*(1+retx);
run;

data p10 ; set p10;
by ind refresh_date;
div = lag(P)*(ep);
if first.refresh_date then div = 100*(ep);
run;

data p10;  set p10; where 1957 < year(refresh_date) le 2005; I=intck('month', refresh_date, date);
year= -4;
if I>-48 then year = -3; 
if I>-36 then year = -2; 
if I>-24 then year = -1; 
if I>-12 then year = 0; 
if I> 0 then year = 1; 
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;


proc sql; create table sums as select distinct
ind, refresh_date, year, mean(div) as div format 11.6
from p10 group by ind, refresh_date, year;

%p10(temp.raws(where = (month(rdate)=6 and year(rdate) > 1957)), &xx);

proc sql; create table chars as select distinct
a.ex, a.ind, a.refresh_date, a.rdate, a.date, -sum(w*b.beta) as low_beta, sum(w*b.bm) as bm, 
sum(w*b.op) as op, -sum(w*b.inv) as low_inv, sum(w*b.pay) as pay, mean(me) as me, sum(w*1) as eg_1, sum(w*1) as eg_2
from p10_w_&xx(where =  (1957 le year(date) le 2005))  a, ind.characteristics b where a.ex=b.ex and a.vid=b.vid and a.rdate=b.rdate group by a.ex, a.ind, a.rdate;

create table temp as select distinct
ind, refresh_date, mean(div) as div from sums(where = (-1 <= year <= 1)) group by ind, refresh_date;

create table temp2 as select distinct
ind, refresh_date, mean(div) as div from sums(where = (13 <= year <= 15)) group by ind, refresh_date;

data temp; set temp; if div < 0 then div = .; run;

proc sql; create table temp.p10_new_e_&xx as select distinct
a.ind, a.refresh_date, a.div as div1, b.div as div2, (b.div/a.div)**(1/14)-1 as growth, c.*
from temp a, temp2 b, chars c
where a.refresh_date=b.refresh_date=c.refresh_date and a.ind=b.ind=c.ind; 

%mend;


%dividends(xx = bm);
%dividends(xx = op);
%dividends(xx = inv);
%dividends(xx = beta);
%dividends(xx = pay);

%earnings(xx = bm);
%earnings(xx = op);
%earnings(xx = inv);
%earnings(xx = beta);
%earnings(xx = pay);



data all_div;  set temp.p10_new_bm;   name = "bm_____" ; run;
data temp; set temp.p10_new_op;   name = "op_" ;     run; proc append data = temp base = all_div FORCE ; run ;
data temp; set temp.p10_new_inv;  name = "inv_" ;    run; proc append data = temp base = all_div FORCE ; run ;
data temp; set temp.p10_new_beta; name = "beta_" ;   run; proc append data = temp base = all_div FORCE ; run ;
data temp; set temp.p10_new_pay;  name = "PAY_" ;    run; proc append data = temp base = all_div FORCE ; run ;
data ind.realized_dividends; set all_div; growth2 = growth*100; run;

data all_earn;  set temp.p10_new_e_bm;   name = "bm_____" ; run;
data temp; set temp.p10_new_e_op;   name = "op_" ;     run; proc append data = temp base = all_earn FORCE ; run ;
data temp; set temp.p10_new_e_inv;  name = "inv_" ;    run; proc append data = temp base = all_earn FORCE ; run ;
data temp; set temp.p10_new_e_beta; name = "beta_" ;   run; proc append data = temp base = all_earn FORCE ; run ;
data temp; set temp.p10_new_e_pay;  name = "PAY_" ;    run; proc append data = temp base = all_earn FORCE ; run ;
data ind.realized_earnings; set all_earn; growth2 = growth*100; run;


proc reg data = ind.realized_dividends; 
model growth2 = bm; 
model growth2 = op; 
model growth2 = low_inv; 
model growth2 = low_beta;
model growth2 = pay; 
model growth2 = bm op low_inv low_beta pay /acov; ;
run;

proc reg data = ind.realized_earnings; 
model growth2 = bm; 
model growth2 = op; 
model growth2 = low_inv; 
model growth2 = low_beta;
model growth2 = pay; 
model growth2 = bm op low_inv low_beta pay /acov; 
run;


*** EXPORT TO STATA ;
PROC EXPORT DATA=ind.realized_dividends  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\ltg\dividends_realized.dta" DBMS=STATA REPLACE; RUN;


*** EXPORT TO STATA ;
PROC EXPORT DATA=ind.realized_earnings  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\ltg\earnings_realized.dta" DBMS=STATA REPLACE; RUN;




