


***************************************************************************
*                                  House cleaning
*************************************************************************** ; 
proc delete data = _all_ ; run ; 



libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
libname ssdf "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\ssdf\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;


**************************************************************************

			PREPARE THE DATA AND COMBINE WITH COMPUSTAT

**************************************************************************;





%let wrds=wrds-cloud.wharton.upenn.edu 4016;
options comamid=TCP remote=WRDS;
signon username=_prompt_;


data summary; set ssdf.summary_raw;run;


rsubmit;

proc upload data = summary; run;

proc sql; 
create table names as select distinct
a.*, b.*
from summary a, comp.g_names b 
where a.share_isin = b.isin; 

create table extras as select distinct
a.*, b.*
from summary a left join comp.g_names b on a.share_isin = b.isin;

data extras; set extras; where year2 = . ;run;

proc sql;
create table names_us as select distinct
a.*, b.isin, b.gvkey
from extras(drop = gvkey isin) a, crsp.sechead b 
where a.share_isin = b.isin; 

proc append data = names_us base = names force; run;

proc download data = names out = names; run;

proc download data = names_us out = names_us;run;

endrsubmit;



*data ind.srip_temp_names; *set names; *run; *Original code saved copy of data in case it is needed; 
data names; set ind.strip_temp_names; run;


proc sql; create table summary_full as select distinct
b.gvkey, a.*, b.*
from summary a left join names b on a.product_id = b.product_id;


********************************************************************

		Manual addition of companies without GVKEYs

				Nordea   : ID = N2DB  GVKEY = 214881
				Vallourec: ID = V3AC  GVKEY = 101467
				Linde    : ID = L2IN  GVKEY = 100037
				Linde    : ID = L3IN  GVKEY = 100037
				BHP		 : ID = B3LT  GVKEY = 105595
				Carnival : ID = C2CL  GVKEY = 140821
********************************************************************;


data summary_full(drop = currency2) ; set summary_full;
if Product_id = "N2DB" THEN GVKEY = "214881";
IF Product_id = "V3AC" THEN GVKEY = "101467";
IF Product_id = "L2IN" THEN GVKEY = "100037";
IF Product_id = "L3IN" THEN GVKEY = "100037";
IF Product_id = "B3LT" THEN GVKEY = "105595";
IF Product_id = "C2CL" THEN GVKEY = "140821";

currency2 = currency;

if currency2 = "$" then currency = "USD";
if currency2 = "" then currency = "EUR";

RUN;


proc sql; create table summary_full2 as select distinct
a.vid, a.ex, b.* from  summary_full b left join rsch.xfa a on a.gvkey = b.gvkey;

proc sort data = summary_full2; by product_id vid; run;

data summary_full2; set summary_full2; by product_id vid; if first.product_id then id = 0; id + 1;
run;

data ssdf.summary; set summary_full2; where id = 1 ; run;


proc delete data = _all_; run;



**************************************************************************

						CREATE TIME SERIES FILE

**************************************************************************;




data ts ; set ssdf._2019; run;

proc append data = ssdf._2018 base = ts force; run;
proc append data = ssdf._2017 base = ts force; run;
proc append data = ssdf._2016 base = ts force; run;
proc append data = ssdf._2015 base = ts force; run;
proc append data = ssdf._2014 base = ts force; run;
proc append data = ssdf._2013 base = ts force; run;
proc append data = ssdf._2012 base = ts force; run;
proc append data = ssdf._2011 base = ts force; run;
proc append data = ssdf._2010 base = ts force; run;

data ts; set ts;
rename F1 = product_id;
rename F2 = date;
rename F3 = exercise;
rename F4 = call_put;
rename F5 = version;
rename F6 = exp_year;
rename F7 = exp_month;
rename F8 = open;
rename F9 = high;
rename F10 = low;
rename F11 = settlement_price;
rename F12 = volume;
rename F13 = open_interest;
run;


data ssdf.ts_raw; set ts; run;


proc sql; create table temprr as select distinct
b.gvkey, b.vid, b.product_id, b.Product, b.currency, b.ex, b.country, a.*, b.* 
from ssdf.ts_raw a, ssdf.summary b where a.product_id = b.product_id;

data temprr; set temprr; *where currency ne "GBX" ; 
settlement_price2 = settlement_price;
if currency = "GBX" then settlement_price = settlement_price2/100;
notional = settlement_price*open_interest*contract_Size;
where open_interest ne 0;
proc sort ; by descending Contract_Size; 
run;

data temprr; set temprr; if currency = "GBX" then currency = "GBP"; 
expiration = MDY(exp_month, 31, exp_year); format expiration yymmddn8.;
run;


proc sort data = temprr; by gvkey expiration date; run;

proc means data = temprr noprint;
by gvkey expiration date;
var settlement_price;
weight open_interest;
output out = prices;
run;


** TEST THAT PRICES ON THE SAME CLAIM ARE SIMILAR;
data test; set temprr; proc sort; by gvkey expiration date product_id; run;
data test; set test; plag = 0; elag=0; dlag =0; glag=0;
if gvkey = lag(gvkey) then glag =1; if expiration = lag(expiration) then elag = 1; 
if  date = lag(date) then dlag = 1; if lag(settlement_price) ne settlement_price then plag = 1;
keep = 0; if elag=dlag=glag=plag=1 then keep = 1;
proc sort ;by gvkey expiration date descending product_id;run;

data test(where = (keep = 1)); set test; if lag(keep)=1 then keep = 1; run;

**;




proc sql;
create table firm_level as select distinct 
gvkey, vid, expiration, date, sum(volume) as volume, sum(open_interest*contract_size)/1000 as open_interest, sum(notional) as notional_sum
from temprr group by gvkey, expiration, date; 

		*** Note that the open_interest is standardized to contract size of 1000; 

create table firm_level2 as select distinct
a.*, b.settlement_price
from firm_level a, prices(where = (_STAT_="MEAN")) b where a.gvkey=b.gvkey and a.expiration=b.expiration and a.date=b.date;


data firm_level3; set firm_level2;
by gvkey expiration date;
retain price 0;
if first.expiration then price = settlement_price;
if volume = 0 then price = price;
if volume > 0 then price = settlement_price;

run;


data firm_level3 ; set firm_level3;
if settlement_price = 0 then price = 0;

notional_price = open_interest*price*1000; 

run;

proc sql; create table firm_unique as select distinct a.*
from ssdf.summary(drop = product_id Product_ISIN product underlying_isin Min_Price_Change contract_size) a order by gvkey;

data firm_unique; set firm_unique; 
if gvkey = "014894" and currency = "EUR" then delete; ** The EUR vodafone strip has no contracts outstanding;
if currency= "GBX" then currency = "GBP";
run;

proc sql;
create table merged as select distinct
a.*, b.*
from firm_level3 a, firm_unique b 
where a.gvkey = b.gvkey ;

data ssdf.ts_price_raw; set firm_level3;run;
data ssdf.ts_price; set merged;run;
data ssdf.summary_unique; set firm_unique; run;



*********************************************
			CREATE MONTHLY RETURN FILE
*********************************************;



data temprr; set ssdf.ts_price; last_day = 0;
month=month(date); year=year(date);
proc sort; by gvkey expiration descending date; run;

data temprr; set temprr;
by gvkey expiration descending year descending month; 
if first.month then last_day = 1;
run;

proc sql; create table monthly as select distinct
gvkey, vid, expiration, year, month, sum(volume) as volume, mean(open_interest) as open_interest
from temprr group by gvkey, expiration, year, month;

create table monthly2 as select distinct
a.*, b.settlement_price, b.price
from monthly a, temprr(where = (last_day=1)) b where a.gvkey=b.gvkey and a.expiration=b.expiration and a.month=b.month and a.year=b.year;

create table monthly3 as select distinct
a.gvkey, a.vid, b.date, a.*
from monthly2 a, rsch.msi(where = (ex="USA")) b where month(b.date)=month and year=year(b.date);

proc sort data = monthly3; by gvkey expiration date; run;

data monthly3; set monthly3;
by gvkey expiration;
ret = price/lag(price) - 1;
ret_settle = settlement_price/lag(settlement_price)-1;
if first.expiration then ret = .;
if first.expiration then ret_settle = .;
format ret ret_settle 11.6;
run;


data ssdf.ts_month; set monthly3; run;

proc delete data = _all_; run;




*********************************************
			CREATE EXPECTED RETURNS
*********************************************;



rsubmit;
proc sql ; 
create table int as select distinct
compress(gvkey||"__"||iid) as vid ,  excntry  as ex,  a.* 
from ibes.STATSUMU_XEPSINT  a , comp.g_security b
where a.ticker = b.ibtic  and USFIRM = 0 and excntry not in ('USA','CAN')  and USFIRM = 0 and MEASURE = 'DPS' and FISCALP = 'ANN' 
and ibtic is not missing and a.ticker is not missing 
order by vid , statpers ; 

proc sql ; 
create table usa as select distinct
"XXXXXXXXXXXX" as vid, permno, "USA" as ex format $3. , a.*
from ibes.Statsumu_xepsus a , crsp.stocknames b
where a.cusip = b.cusip and st_date<= STATPERS<= end_date and USFIRM = 1 and MEASURE = 'DPS' and FISCALP = 'ANN'  and a.ticker is not missing ;

data usa(drop = permno); set usa; if permno ^=. then vid = compress("USA"||permno); run;

proc append data = usa base = int force ;run;


proc download data=int(where = (year(statpers) ge 2009)) out=ibes_expectations; ** code saves data in working directory to not overun the file in the ssdf library (which the code below uses). This is a change only applied to the final code so as to not override data in future replication;
run;
endrsubmit;



proc sql; create table temprr as select distinct a.*, b.medest as expected_median label "expected_median" format 9.4,
b.meanest as expected_mean label "expected_mean" format 9.4, b.CURCODE, b.statpers, FPEDATS, b.numest
from ssdf.ts_month a left join ssdf.ibes_expectations b on a.vid = b.vid and month(a.date)=month(b.statpers) and year(a.date)=year(b.statpers)
and month(a.expiration)=month(b.FPEDATS) and year(a.expiration)=year(b.FPEDATS);

create table temprr2 as select distinct a.*, b.currency
from temprr a , ssdf.summary_unique b where a.gvkey=b.gvkey;

data temprr2; set temprr2;

maturity = intck('month', date, expiration);

if curcode = "BPN" then do;

expected_median = expected_median/100;
expected_mean = expected_mean/100;
curcode = "GBP";

end;

eret = (expected_median/price)**(12/maturity) -1 ;
eret_settle = (expected_median/settlement_price)**(12/maturity) - 1;
format eret eret_settle 9.4;

run;


data temprr3; set temprr2;

flag_eret = 0;
if eret le -0.1 then flag_eret = 1;
if eret ge 0.3 then flag_eret = 1 ;
*if abs(eret) > 0.5 then eret = .;
*if abs(eret_settle) > 0.5 then eret_settle = .;
if CURCODE ne Currency then eret = .;
if CURCODE ne Currency then eret_settle = .;
if expected_median = . then eret = .;
if expected_median = . then eret_settle = .;

notional = open_interest*price;

run;

data ssdf.expected_returns; set temprr3; run;


proc delete data = _all_;run;









*********************************************
			CREATE ANNUAL RETURN FILE
*********************************************;


data temprr; set ssdf.ts_price; last_day = 0;
month=month(date); year=year(date);
proc sort; by gvkey expiration year descending date; run;

data temprr; set temprr;
by gvkey expiration year descending date; 
if first.year then last_day = 1;
run;

proc sql; create table yearly as select distinct
gvkey, vid, expiration, year, sum(volume) as volume, mean(open_interest) as open_interest
from temprr group by gvkey, expiration, year;

create table yearly2 as select distinct
a.gvkey, a.vid, b.date, a.*
from yearly a, rsch.msi(where = (ex="USA" and month(date)=12)) b where year=year(b.date);


create table yearly3 as select distinct
a.*, b.settlement_price, b.price
from yearly2 a, temprr(where = (last_day=1)) b where a.gvkey=b.gvkey and a.expiration=b.expiration and a.year=b.year;

proc sort data = yearly3; by gvkey expiration descending date; run;

data yearly3; set yearly3;
by gvkey expiration;


price_final = price;

maturity = intck('month', date, expiration) ;

if maturity = 0 then price_final = settlement_price;

ret = lag(price_final)/price_final - 1;

ret_settle = lag(settlement_price)/settlement_price-1;
future_date = lag(date);

if first.expiration then ret = .;
if first.expiration then ret_settle = .;
if first.expiration then future_date = .;

format ret ret_settle 11.6;
run;

data ssdf.ts_year; set yearly3; run;

proc delete data = _all_; run;




*********************************************
			CREATE BETAS
*********************************************;


** PREPARE LOCAL MARKET FACTORS IN OWN CURRENCY;

data input; set rsch.msf; by vid date; if first.vid then id = 1; lag_me = lag(me); if id=1 then lag_me = . ; proc sort; by ex date; run;

proc means data = input; by ex date; var loc_ret; weight lag_me ; output out = msi_local; run;

data ind.msi_local; set msi_local(where = (_STAT_="MEAN")); keep ex date loc_ret ; run; 



** Create betas;


data ts; set ssdf.ts_month; 
maturity = intck('month', date, expiration);
mat = 1;
if maturity > 12 then mat =2;
if maturity > 24 then mat =3;
if maturity > 36 then mat =4 ;
if maturity > 48 then mat =5 ;
if maturity > 60 then mat =6 ;
run;

proc sql; create table ts3 as select distinct
a.*, b.ex from ts a , ssdf.summary_unique b where a.gvkey = b.gvkey;

create table ts2 as select distinct a.*, std(ret) as std
from ts a group by vid, mat;

proc sql; create table mkt as select distinct
a.*, b.* from rsch.msi a, ind.msi_local b where a.ex=b.ex and a.date=b.date;

data mkt; set mkt; by ex date; if first.ex then id = 0; id+1;
m = loc_ret-rf;  mkt = m ; mkt1=lag(m); mkt2 = lag2(m); mkt3 = lag3(m); mkt4 = lag4(m); mkt5 = lag5(m); mkt6 = lag6(m);
if id le 6 then delete; 
run; 

proc sql;
create table temprr as select distinct
a.*, b.*
from ts3 a, mkt b  where a.ex=b.ex and intck('month', a.date, b.date)=0
order by vid, mat, date;

proc reg data = temprr noprint rsquare outest=ob; 
model ret_settle = mkt mkt1 mkt2 mkt3 mkt4 mkt5; 
by vid mat;
where ret_settle ne 0 and ret ne . and open_interest > 0 and maturity > 6;
restrict mkt3=mkt4=mkt5;
run;

data ob; set ob;
beta = sum(mkt, mkt1, mkt2, mkt3, mkt4, mkt5) ;
numobs_beta = _P_ + _EDF_;
run;

proc sql; 
create table betas as select distinct
a.*, b.beta as beta format 11.6, numobs_beta 
from ts3 a, ob b where a.vid=b.vid and a.mat=b.mat group by a.vid, a.mat
order by mat; 

data betas(drop = beta_strip2); set betas;
beta_strip = beta;
beta_strip2 = beta_strip;
if beta_strip2 > 1.5 then beta_strip = 1.5;
if beta_strip2 < -1 then beta_strip = -1;


beta_windsor = beta;

run;



%windsor(dataset = betas, var = beta_windsor, byvar = mat, p1=5, p2 = 95);


data betas; set betas; run;


proc sql; create table strips as select distinct
vid, mat, beta_strip, beta_windsor from betas;

create table temp1 as select distinct
a.*, b.beta_strip as beta_strip1, b.beta_windsor as beta_windsor1
from betas a left join strips(where = (mat=1)) b on a.vid=b.vid;

create table temp2 as select distinct
a.*, b.beta_strip as beta_strip2, b.beta_windsor as beta_windsor2
from temp1 a left join strips(where = (mat=2)) b on a.vid=b.vid;

create table temp3 as select distinct
a.*, b.beta_strip as beta_strip3, b.beta_windsor as beta_windsor3
from temp2 a left join strips(where = (mat=3)) b on a.vid=b.vid;

create table temp4 as select distinct
a.*, b.beta_strip as beta_strip4, b.beta_windsor as beta_windsor4
from temp3 a left join strips(where = (mat=4)) b on a.vid=b.vid;


data temp4; set temp4;
if mat = 1 then beta_yield = beta_strip1;
if mat = 2 then beta_yield = mean(beta_strip1, beta_strip2);
if mat = 3 then beta_yield = mean(beta_strip1, beta_strip2, beta_strip3);
if mat = 4 then beta_yield = mean(beta_strip1, beta_strip2, beta_strip3, beta_strip4);


if mat = 1 then beta_yield_win = beta_windsor1;
if mat = 2 then beta_yield_win = mean(beta_windsor1, beta_windsor2);
if mat = 3 then beta_yield_win = mean(beta_windsor1, beta_windsor2, beta_windsor3);
if mat = 4 then beta_yield_win = mean(beta_windsor1, beta_windsor2, beta_windsor3, beta_windsor4);

run;


data ssdf.betas; set temp4; run;





******************************************************************************************
									CREATE FINAL FILES
******************************************************************************************;

proc sql;create table temprr as select distinct
a.*, b.* from ssdf.expected_returns a, ssdf.summary_unique b where a.gvkey=b.gvkey;

create table temprr2 as select distinct
a.*, c.dur, bm, mep, op, inv, c.beta, pay
from temprr(where = (month(date)=12)) a, ind.msf_dur c where a.vid=c.vid and intck('month', a.date, c.rdate)=0;

create table annual as select distinct
a.*, b.beta_strip format 11.6, b.beta_yield format 11.6, b.beta_windsor format 11.6, b.beta_yield_win format 11.6, numobs_beta
from temprr2 a, ssdf.betas b where a.vid=b.vid and a.date=b.date and a.expiration=b.expiration; 

data ind.strips_annual ;set annual;



alpha = eret - beta_yield * 0.05;
alpha_windsor = eret - beta_yield_win * 0.05;

y1=0;y2=0;y3=0;y4=0;y5=0;

if maturity = 12 then y1 = 1;
if maturity = 24 then y2 = 1;
if maturity = 36 then y3 = 1;
if maturity = 48 then y4 = 1;
if maturity = 60 then y5 = 1;

if maturity = 0 then delete;
if maturity = . then delete;

delete_beta = 0;

if beta_strip < -2 then delete_beta = 1;
if beta_strip >  2 then delete_beta = 1;


if maturity = 0 then mat = 0;

if maturity > 0 then mat = 1;
if maturity > 12 then mat =2;
if maturity > 24 then mat =3;
if maturity > 36 then mat =4 ;
if maturity > 48 then mat =5 ;
if maturity > 60 then mat =6 ;

if maturity ge 72 then delete;

run;

proc delete data = _all_ ; run;




** Annual Realized ;


data msf_temp1;
set ind.msf_dur; 
dur_pct = dur;
proc sort; by ex rdate; run;

proc rank data = msf_temp1 out = msf_temp2 percent; by ex rdate; var dur_pct; run;
data msf_dur; set msf_temp2; run;

proc sql;create table temprr as select distinct
a.*, b.* from ssdf.ts_year a, ssdf.summary_unique b where a.gvkey=b.gvkey;

create table temprr2 as select distinct
a.*, c.dur, dur_pct, bm, mep, op, inv, c.beta, pay
from temprr(where = (month(date)=12)) a, msf_dur c where a.vid=c.vid and intck('month', a.date, c.rdate)=0;

create table annual as select distinct
a.*, b.beta_strip as beta_strip format 11.6, b.beta_windsor as beta_windsor format 11.6, numobs_beta
from temprr2 a, ssdf.betas b where a.vid=b.vid and a.date=b.date and a.expiration=b.expiration; 

data market; set ind.msi_local; where year(date) ge 2010; proc sort; by ex date; run;

data market; set market;
by ex;
retain cum 1;
cum = cum*(1+loc_ret);

proc sort; by ex descending date;
run;

data market; set market;
by ex; 
if first.ex then id = 0;
id +1;
ret_mkt = lag12(cum)/cum-1;
future_date = lag12(date);

if id le 12 then ret_mkt = .;
if id le 12 then future_date = .;

format ret_mkt 11.6;
format future_date yymmddn8.;

run;

proc sql; create table annual2 as select distinct
a.*, b.ret_mkt from annual a , market b where a.ex=b.ex and a.date=b.date; 


data annual2 ;set annual2;

log_ret = log(1+ret);
log_ret_settle = log(1+ret_settle);


alpha = ret - beta_strip * ret_mkt;
alpha_windsor = ret - beta_windsor * ret_mkt;
alpha_settle = ret_settle - beta_strip * ret_mkt;


log_alpha = log_ret - beta_strip * ret_mkt;


maturity = intck('month', date, expiration);

y1=0;y2=0;y3=0;y4=0;y5=0;

if maturity = 12 then y1 = 1;
if maturity = 24 then y2 = 1;
if maturity = 36 then y3 = 1;
if maturity = 48 then y4 = 1;
if maturity = 60 then y5 = 1;

if maturity = 0 then delete;
if maturity = . then delete;

delete_beta = 0;

if beta_strip < -2 then delete_beta = 1;
if beta_strip >  2 then delete_beta = 1;


if maturity = 0 then mat = 0;

if maturity > 0 then mat = 1;
if maturity > 12 then mat =2;
if maturity > 24 then mat =3;
if maturity > 36 then mat =4 ;
if maturity > 48 then mat =5 ;
if maturity > 60 then mat =6 ;

if maturity ge 72 then delete;

notional = price*open_interest; 

run;

proc sql; create table annual3 as select distinct
a.*, b.eret, b.flag_eret, b.alpha as ealpha, b.alpha_windsor as ealpha_windsor, b.beta_yield, b.beta_yield_win from annual2 a left join ind.strips_annual b on a.gvkey = b.gvkey and a.expiration=b.expiration and a.date=b.date;

data beta; set rsch.betas_fp; beta_raw = beta; proc sort ; by ex rdate; run;

proc sql;  create table annual4 as select distinct
 a.*, b.beta_raw as beta_raw from annual3 a left join beta b 
 on a.vid=b.vid and a.date=b.rdate;

data ind.strips_annual_realized; set annual4;
keep gvkey vid date expiration year volume open_interest maturity ret ret_settle future_date
ex  Currency Country conm price
dur dur_pct bm mep OP INV beta PAY beta_strip numobs_beta 
ret_mkt beta_strip2 log_ret log_ret_settle alpha alpha_settle log_alpha y1 y2 y3 y4 y5 mat notional 
eret flag_eret ealpha beta_raw beta_yield ealpha ealpha_windsor alpha_windsor beta_yield beta_windsor beta_yield_win;

format open_interest beta_strip2 ealpha 9.2;
format ealpha 9.6;
run;


PROC EXPORT DATA=ind.strips_annual_realized  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\strips\annual.dta" DBMS=STATA REPLACE; RUN;






proc delete data = _all_ ; run;



** Monthly file; 



proc sql;create table temprr as select distinct
a.*, b.* from ssdf.expected_returns a, ssdf.summary_unique b where a.gvkey=b.gvkey;

create table temprr2 as select distinct
a.*, c.dur, bm, mep, op, inv, c.beta, pay
from temprr a, ind.msf_dur c where a.vid=c.vid and intck('month', a.date, c.rdate)=0;

create table monthly as select distinct
a.*, b.beta as beta_strip format 11.6, numobs_beta
from temprr2 a, ssdf.betas b where a.vid=b.vid and a.date=b.date and a.expiration=b.expiration; 


data ind.strips_monthly ;set monthly;
alpha = ret - beta_strip * (0.05/12);
alpha_settle = ret_settle - beta_strip * (0.05/12);

log_ret = log(1+ret);
log_ret_settle = log(1+ret_settle);

if ret_settle = . then alpha_settle = . ;

y1=0;y2=0;y3=0;y4=0;y5=0;y01=0;

delete_obs = 0 ;

*if maturity = 0 then delete_obs = 1;

if 0  le maturity le 12 then y01 = 1;
if 0  < maturity  le 12 then y1  = 1;
if 12 < maturity  le 24 then y2  = 1;
if 24 < maturity  le 36 then y3  = 1;
if 36 < maturity  le 48 then y4  = 1;
if 48 < maturity  le 60 then y5  = 1;

if maturity > 60 then delete_obs = 1;

if maturity = . then delete;


delete_beta = 0;
if beta_strip < -2 then delete_beta = 1;
if beta_strip >  2 then delete_beta = 1;

quarter = qtr(date);



if maturity = 0 then mat = 0;

if maturity > 0 then mat = 1;
if maturity > 12 then mat =2;
if maturity > 24 then mat =3;
if maturity > 36 then mat =4 ;
if maturity > 48 then mat =5 ;
if maturity > 60 then mat =6 ;

if maturity ge 72 then delete;

run;

proc delete data = _all_ ; run;


PROC EXPORT DATA=ind.strips_monthly  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\strips\monthly.dta" DBMS=STATA REPLACE; RUN;





data test; set ind.strips_monthly; 
proc sort; by gvkey expiration date;run;

data test; set test;
retain last_ret 0;
if first.expiration then last_ret = 0;
if ret = 0 then last_ret = last_ret;
if ret ne 0 then last_ret = ret;

proc sort; by gvkey expiration descending date;run;
run;




data test; set test;
by gvkey expiration descending date;
lead_ret = lag(ret);
if first.expiration then lead_ret = 0;
run;


** AR1 regressions: slightly positive autocorrelation (slope 0.03 and R2 = 0.0014);

proc reg data = test ; model lead_ret = last_ret;
where lead_ret ne 0;
run;


PROC EXPORT DATA=test  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\strips\AR_test.dta" DBMS=STATA REPLACE; RUN;




**************************************************************************

								EXAMPLES

**************************************************************************;


data AXA; set ssdf.ts_price; where gvkey="063120" and year(expiration)=2020;run;

proc sql; create table AXA_trades as select distinct
sum(volume ne 0) as trades, sum(volume ne .) as total , sum(volume ne 0) as trades, sum(volume ne 0)/sum(volume ne .) as total as ratio format 9.2
from AXA; 


data DB; set ssdf.ts_price; where gvkey="015576" and year(expiration)=2020;run;

proc sql; create table DB_trades as select distinct
sum(volume ne 0) as trades, sum(volume ne .) as total , sum(volume ne 0) as trades, sum(volume ne 0)/sum(volume ne .) as total as ratio format 9.2
from DB; 



%export_results(AXA);
%export_results(DB);







**************************************************************************

								Approximate market size

**************************************************************************;



proc sql; create table aa as select distinct
a.*, b.*
from ssdf.ts_price a, ssdf.summary_unique b where a.gvkey=b.gvkey;



data aa; set aa;

eur_price = settlement_price;

if Currency="USD" then eur_price = settlement_price*0.88;
if Currency="CHF" then eur_price = settlement_price*0.89;
if Currency="GBP" then eur_price = settlement_price*0.10;

notional = open_interest*settlement_price*1000;
notional2 = open_interest*eur_price*1000;


turnover = volume * eur_price; 

month=month(date);
year=year(date); 

run;



proc sql; create table test as select distinct
date, sum(volume)/1000 as vol, sum(open_interest)/1000000 as open_interest, sum(notional)/1000000000 as notional format 9.4, sum(notional2)/1000000000 as notional2 format 9.4, sum(turnover)/1000 as turnover format 9.4
from aa group by date;


proc sql; create table test as select distinct
year, month, sum(volume*1000)/1000000 as volume format 9.4, sum(turnover*1000)/1000000 as turnover format 9.4
from aa group by year;


