libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;



data factors_eben;
set ind.factors;
run;

%export_results(factors_eben); 

data p10; set ind.p10_dur; where ex = "USA";run;

%export_results(p10); 


**************************************************************************

					TABLE 1 and FIGURE 2 Growth Rates and Characteristics

**************************************************************************;

***Panel B: UNIVARIATE CORRELATIONS ;
*proc sql; 
*create table temp as select distinct a.*, a.me as mew, -a.inv as low_inv, -a.beta as low_beta, -a.iv as low_iv,  b.dur from ind.msf_exp a, ind.msf_dur b
where a.rdate=b.rdate and a.vid=b.vid order by ex, rdate;
data msf_ltg; set ind.msf_exp_percent; low_inv=-inv; low_beta=-beta; ; proc sort; by ex rdate; run;
proc corr data = msf_ltg noprint out=b; where ex = "USA" ; var medest bm op low_inv low_beta pay ;run; 
data Table2b; set b ; where _NAME_ = "MEDEST" ; run ;
proc delete data = temp b; run; 

******** TURN THIS INTO TABLE2B

***Panel C and D: EXPORT TO STATA ;
 PROC EXPORT DATA=msf_ltg  FILE="c:\users\ngormsen\dropbox\DurationBasedAP\final version\data and programs\submitted code\STATA\data\ltg\msf_exp_percent.dta" DBMS=STATA REPLACE; RUN;


***Figure 2: LOADING BY COUNTRY;
proc reg data = msf_ltg noprint tableout outest = b rsquare; by ex ; *where NUMEST > 5; model medest = bm op low_inv low_beta pay; weight numest; run; quit;
data Table_growth_int; set b; where  _TYPE_="PARMS" or _TYPE_ = "T" ; drop _MODEL_ _DEPVAR_ _RMSE_ intercept medest;  ;run; 
data Figure_growth_int; set b; where  _TYPE_="PARMS" ;drop _MODEL_ _DEPVAR_ _RMSE_ intercept medest;  run; data Figure_growth_int_t; set b; where  _TYPE_="T"; run; 



%export_results(Table2A);
%export_results(Table2AA);
%export_results(Table2B);
%export_results(Figure_growth_int);


proc delete data = _all_ ; run;


%Table1(infile=ind.p10_dur(where = (ex="USA" and year(date) ge 1929)), infile2 = ind.p10_divs);
data Table3; set Table1; run;
%export_results(Table3);
proc delete data = _all_ ;run;



**************************************************************************

					TABLE 3 and 4 DURATION RISK FACTOR

**************************************************************************;



%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 0  , out=smb_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 1  , out=smb_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 0  , out=hml_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 1  , out=hml_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 0  , out=rmw_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 1  , out=rmw_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 0  , out=cma_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 1  , out=cma_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 0  , out=pay_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = ind.factors(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 1  , out=pay_d, infile2=ind.ltg_factors(where = (ex="USA")));

data Table3A; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

proc sql; create table div as select distinct "USA" as ex, a.ind, a.div as div_1, b.div as div_2, a.inf
from ind.factor_divs(where = (year=1)) a, ind.factor_divs(where = (year=15)) b where a.ind=b.ind;
data div(keep = ex ind growth inf); set div; growth = ((div_2/div_1)**(1/15))/(1+inf)-1; if ind = 11 then growth = . ; format growth 9.6; run;
proc transpose data = div out = Table3A_growth; ID ind; run;

proc sql; create table earn as select distinct "USA" as ex, a.ind, a.earn as earn_1, b.earn as earn_2, a.inf
from ind.factor_earn(where = (year=1)) a, ind.factor_earn(where = (year=15)) b where a.ind=b.ind;
data earn(keep = ex ind growth_earn); set earn; growth_earn = ((earn_2/earn_1)**(1/15))/(1+inf)-1; if ind = 11 then growth = . ; format growth 9.6; run;
proc transpose data = earn out = Table3A_growth2; ID ind; run;
proc append data = Table3A_growth2 base = Table3A_growth force; run;


data Figure3; set ind.factor_divs_t;run;

data Table4A; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table4B; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;
proc delete data = div iv_c ic_d pay_c pay_d dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;


%export_results(Table3A);
%export_results(Table3A_growth);
%export_results(Figure3);
%export_results(Table4A);
%export_results(Table4B);


%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 0 , out=smb_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 1 , out=smb_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 0 , out=hml_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 1 , out=hml_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 0 , out=rmw_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 1 , out=rmw_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 0 , out=cma_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 1 , out=cma_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 0 , out=pay_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = ind.factors(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 1 , out=pay_d, infile2=ind.ltg_factors(where = (ex="WOR")));

data Table3B; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table5A; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table5B; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;

%export_results(Table3B);
%export_results(Table5A);
%export_results(Table5B);

proc delete data =iv_c ic_d pay_c pay_d  dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;
proc delete data = _all_ ; run ;

*International data; 

proc sql;create table dur as select distinct a.*, b.* from ind.dur a , rsch.msi b where a.ex=b.ex and a.date=b.date;
create table dur as select distinct a.*, b.* from dur(where = (date > MDY(7,1,1963))) a left join rsch.ff5 b on a.ex=b.ex and a.date=b.date; 

proc reg data = dur noprint tableout outest = b_capm; by ex ; model dur = mkt ; output out = b2_capm residual =resi_capm; run ;

proc sql; create table country_level as select distinct 
a.ex, 100*a.intercept as alpha_capm format 9.4, c.intercept as t_capm label "T_capm", sqrt(12)*a.intercept/(std(b.resi_capm)) as IR_capm format 9.4 
from b_capm(where = (_TYPE_="PARMS")) a , b2_capm b, b_capm(where = (_TYPE_="T")) c where a.ex=b.ex=c.ex group by b.ex;

%export_results(country_level);

proc delete data = _all_;run;


***Times Series of Alpha;

proc reg data = ind.dur outest = b; where ex ="USA"; model dur = mkt ;output out = residual residual = e; run;quit;
proc sql; create table figure_dur_ts_us as select distinct a.ex, a.date, a.dur, a.mkt, a.e+intercept as alpha format 11.6 from residual a, b b;quit;
%export_results(figure_dur_ts_us);

proc reg data = ind.dur outest = b; where ex = "WOR"; model dur = mkt ;output out = residual residual = e; run;quit;
proc sql; create table figure_dur_ts_wor as select distinct a.ex, a.date, a.dur, a.mkt, a.e+intercept as alpha format 11.6 from residual a, b b;quit;
%export_results(figure_dur_ts_wor);

















**************************************************************************

						APPENDIX TABLES

**************************************************************************;


proc reg data = ind.msf_exp_percent noprint outest = b1 rsquare; by ex; model medest = op bm inv beta pay ; weight numest; run; quit;

proc sql; create table temp3 as select distinct
a.*, b.op as bop, b.inv as binv, b.beta as bbeta, b.bm as bbm, b.pay as bpay
from ind.raws a , b1 b where a.ex=b.ex
order by ex, rdate;

data temp3; set temp3; proc sort; by ex rdate; run;

proc rank data = temp3 out = temp4 percent; by ex rdate; var op inv bm mep beta pay ; run; 

data temp4; set temp4;rmw = op ; cma = - inv; 
inv2 = inv;    if inv = .  then inv2   = 50;
op2 = op;      if op = .   then op2    = 50;
bm2 = bm;      if bm = .   then bm2    = 50;
beta2 = beta;  if beta = . then beta2  = 50;
pay2 = pay;    if pay = .  then pay2   = 50;

o   = op2*bop;
in  = inv2*binv;
b   = bm2*bbm;
bet = beta2 * bbeta;
p   = pay2 * bpay;
dur = sum(o, in, p, bet); 


***** Alternative specification based on univariate correlations ****** ;

*o   = op2	 * 0.09;
*in  = inv2	 * 0.35;
*bet = beta2  * 0.37;
*p   = pay2   * 0.35;
*dur = sum(o, in, p, bet); 

*** Alternative based on simple averages ***** ;

op_t = -1*op; pay_t = -1*pay; bm_t = -1*bm;

dur1 = sum(op_t, pay_t, beta2, inv2, bm_t);
dur2 = sum(op_t, pay_t, beta2, inv2);

keep_obs = 1;
if beta = . and inv = . and op = . and pay = . then keep_obs = 0; 

run;

data temp.msf_dur; set temp4;format dur 9.4; keep dur1 dur2 ex me me_company exchcd cma rmw op inv bm rdate vid dur beta iv bop binv bbm biv bbeta beta2 iv2 bm2 op2 inv2 bop binv bbm biv bbeta ltg_hat m bme mep mep2 medest p pay bpay keep_obs; run;

data msf_dur; set temp.msf_dur(where = (month(rdate) = 6 and keep_obs = 1)); dur1 = - dur1; dur2 = -dur2; run; 

%portfolio(infile=msf_dur, sizevar = me, xvar = dur1, keep_all = 1, k = 12, uscondsort=0, keepsmb=1); 
proc sql; create table temp.factors1 as select distinct
a.dur1 as dur, a.smb as dur_smb, b.*
from dur1 a , ind.factors b where a.ex=b.ex and a.date=b.date;


%portfolio(infile=msf_dur, sizevar = me, xvar = dur2, keep_all = 1, k = 12, uscondsort=0, keepsmb=1); 
proc sql; create table temp.factors2 as select distinct
a.dur2 as dur, a.smb as dur_smb, b.*
from dur2 a , ind.factors b where a.ex=b.ex and a.date=b.date;



%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 0  , out=smb_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 1  , out=smb_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 0  , out=hml_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 1  , out=hml_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 0  , out=rmw_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 1  , out=rmw_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 0  , out=cma_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 1  , out=cma_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 0   , out=iv_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 1   , out=iv_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 0  , out=pay_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 1  , out=pay_d, infile2=ind.ltg_factors(where = (ex="USA")));

data Table3A_App; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table4A_App; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table4B_App; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;
proc delete data = div iv_c ic_d pay_c pay_d dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;


%export_results(Table3A_App);
%export_results(Table4A_App);
%export_results(Table4B_App);


%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 0 , out=smb_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 1 , out=smb_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 0 , out=hml_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 1 , out=hml_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 0 , out=rmw_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 1 , out=rmw_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 0 , out=cma_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 1 , out=cma_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 0 , out=iv_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 1 , out=iv_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 0 , out=pay_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 1 , out=pay_d, infile2=ind.ltg_factors(where = (ex="WOR")));

data Table3B_App; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table5A_App; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table5B_App; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;

%export_results(Table3B_App);
%export_results(Table5A_App);
%export_results(Table5B_App);

proc delete data =iv_c ic_d pay_c pay_d  dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;
proc delete data = _all_ ; run ;






%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 0  , out=smb_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 1  , out=smb_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 0  , out=hml_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 1  , out=hml_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 0  , out=rmw_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 1  , out=rmw_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 0  , out=cma_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 1  , out=cma_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 0   , out=iv_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 1   , out=iv_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 0  , out=pay_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 1  , out=pay_d, infile2=ind.ltg_factors(where = (ex="USA")));

data Table3A_App2; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table4A_App2; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table4B_App2; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;
proc delete data = div iv_c ic_d pay_c pay_d dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;


%export_results(Table3A_App2);
%export_results(Table4A_App2);
%export_results(Table4B_App2);


%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 0 , out=smb_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 1 , out=smb_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 0 , out=hml_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 1 , out=hml_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 0 , out=rmw_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 1 , out=rmw_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 0 , out=cma_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 1 , out=cma_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 0 , out=iv_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 1 , out=iv_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 0 , out=pay_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 1 , out=pay_d, infile2=ind.ltg_factors(where = (ex="WOR")));

data Table3B_App2; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table5A_App2; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table5B_App2; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;

%export_results(Table3B_App2);
%export_results(Table5A_App2);
%export_results(Table5B_App2);

proc delete data =iv_c ic_d pay_c pay_d  dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;
proc delete data = _all_ ; run ;





********************************************************************************************
	
									Table: Yield Curve

*******************************************************************************************;

proc sql ; create table predict as select distinct a.*, b.* 
from ind.price_dur a left join ind.factors_predict b on a.ex=b.ex  and a.date=b.date ; 

data predict ; set predict ; level_lc = mean(bm_long_lc, bm_short_lc); level_sc = mean(bm_long_sc, bm_short_sc);
slope_lc = -1*(bm_long_lc- bm_short_lc); slope_sc = -1* (bm_long_sc- bm_short_sc); run;

data predict; set predict; bm_short = mean(level_lc, level_sc); bm_long = mean(slope_lc, slope_sc); 
level = mean(level_lc, level_sc); slope = mean(slope_lc, slope_sc);  run;

proc sql; create table yields as select distinct
a.ex, a.date, a.level, a.slope, b.slope as slope_bonds format 9.6
from predict(where = (ex="USA")) a left join ind.treasury_slope b on a.date=b.date;

data yields(drop = slope_bonds2); set yields; slope_bonds2= slope_bonds; if slope_bonds2 = 0 then slope_bonds = . ; run;



%regression_slope(infile = yields, xvar=slope, out=slope_1);
%regression_slope(infile = yields(where = ( ex = "USA" and year(date) le 1974)), xvar=slope, out=slope_2);
%regression_slope(infile = yields(where = ( ex = "USA" and 1974 < year(date) le 1995)), xvar=slope, out=slope_3);
%regression_slope(infile = yields(where = ( ex = "USA" and 1995 < year(date))), xvar=slope, out=slope_4);

data Table7_new; merge slope_1 slope_2 slope_3 slope_4; run;

%export_results(Table7_new);
data yields; set yields; where ex = "USA" ; run;
%export_results(yields);


proc sql; create table predict as select distinct
a.*, b.slope as slope_bonds format 9.6
from predict(where = (ex="USA")) a left join ind.treasury_slope b on a.date=b.date;

%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=d, out=predict_d);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=s, out=predict_s);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=h, out=predict_h);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=r, out=predict_r);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=c, out=predict_c);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=b, out=predict_b);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=i, out=predict_i);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=p, out=predict_p);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m, out=predict_m);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m2, out=predict_m2, lags = 24);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m3, out=predict_m3, lags = 36);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m4, out=predict_m4, lags = 48);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m5, out=predict_m5, lags = 60);

data Table7a; merge predict_d predict_s predict_h predict_r predict_c predict_b predict_i predict_p; run;
data Table7b; merge predict_m predict_m2 predict_m3 predict_m4 predict_m5;	run;

%export_results(Table7a);
%export_results(Table7b);

proc delete data = predict_d predict_s predict_h predict_r predict_c predict_b predict_m predict_m2 predict_m3 predict_m4 predict_m5; run ;

