libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;



data Ccmxpf_linktable; 
set ind.bondcrsp_link; 
if permno ^=. then vid = compress("USA"||permno) ; run ; 

proc sql ; 
create table wrds_extract as select distinct 
b.vid, a.*
from ind.bondret a , Ccmxpf_linktable b
where a.cusip=b.cusip and link_startdt <= a.date <= link_enddt
and crsp_startdt <= a.date <=crsp_enddt and trace_startdt  <= a.date <= trace_enddt;



proc sql; 
create table temprr as select distinct
a.vid, a.date, b.date, intck('years', a.date, maturity) as mat, a.*, b.medest, op, inv, bm, dur, me, pay, beta, RET_EOM as ret format 11.6
from wrds_extract a, ind.msf_exp_percent b
where a.vid=b.vid and intck('month', a.date, b.date)=-1;

create table temprr3 as select distinct
a.*, b.*
from temprr a, crsp.trates b where intck('month', a.date, b.date)=0
order by date;

proc rank data = temprr3 out = temprr2 PERCENT;
by date;
var bm op inv beta pay dur medest;
run;


proc sql; create table nr_bonds as select distinct CUSIP from temprr2;
proc sql; create table nr_firms as select distinct VID from temprr2;
proc sql; create table dates as select distinct min(date) as start format yymmddn8., max(date) as end format yymmddn8. from temprr;




%macro sorts(xvar=medest);
data temprr2a(where = (firm ne .)); set temprr2;
fret = ret - t30ret; 
if mat ge 2 then fret=ret-b2ret;
if mat ge 4 then fret=ret-b5ret;
if mat ge 8 then fret=ret-b7ret;
if mat ge 13 then fret=ret-b10ret;
if mat ge 25 then fret=ret-b20ret;
if mat ge 30 then fret=ret-b30ret;
mat_type=1;
if mat ge 2 then mat_type=2;
if mat ge 5 then mat_type=3;
if mat ge 7 then mat_type=4;
if mat ge 10 then mat_type=5;
if mat ge 20 then mat_type=6;
if mat ge 30 then mat_type=7;

type=&xvar; 
if type < 50 then firm = 0;
if type ge 50 then firm = 1;
run;


proc sql; create table temprr3 as select distinct
a.*, mean(fret) as mkt from temprr2a a group by date order by vid, date;


proc sql;
create table ports as select distinct
firm, mat_type, date, mean(fret) as fret format 11.6, mkt 
from temprr3 group by firm, mat_type, date; 

create table results as select distinct
firm, mat_type, 12*mean(fret) as fret format 9.4, std(fret) as std format 9.4,
sqrt(12)*mean(fret)/std(fret) as Sharpe, 100*12*mean(mkt) as mkt, sum(fret ne .) as num
from ports group by firm, mat_type; 


proc reg  data = ports noprint tableout outest=b1;
by firm mat_type;  model fret = mkt ; run; run;

proc sql; create table results as select distinct a.*, 
b.mkt as beta, 12*b.intercept as alpha format 9.6, c.intercept as talpha format 9.6
from results a, b1(where = (_TYPE_="PARMS")) b, b1(where = (_TYPE_="T")) c
where a.firm = b.firm=c.firm and a.mat_type=b.mat_type=c.mat_type;

data &xvar ; set results; run;

proc delete data = temprr2a temprr3 temprr4 ;run;

%mend; 

%sorts(xvar=medest);
%sorts(xvar=dur);
%sorts(xvar=bm);
%sorts(xvar=op);
%sorts(xvar=inv);
%sorts(xvar=beta);
%sorts(xvar=pay);

data medest; set medest; type = "medest   " ;run;
data dur; set dur; type = "dur " ;run;
data bm; set bm; type = "bm " ;run;
data op; set op; type = "op  " ;run;
data inv; set inv; type = "inv  " ;run;
data medest; set medest; type = "medest   " ;run;
data beta; set beta; type = "beta   " ;run;
data pay; set pay; type = "pay   " ;run;

proc append data = dur base = medest force;run;
proc append data = bm base = medest force;run;
proc append data = op base = medest force;run;
proc append data = inv base = medest force;run;
proc append data = beta base = medest force;run;
proc append data = pay base = medest force;run;

data bond_table ;set medest; drop num; run;





%export_results(bond_table);

