libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;





********************************************************

				PREPARE TREASURY YIELDS 

********************************************************;



%let wrds=wrds-cloud.wharton.upenn.edu 4016;
options comamid=TCP remote=WRDS;
signon username=_prompt_;


rsubmit;


data temp; set crspa.tfz_mth;
keep  KYTREASNO KYCRSPID MCALDT tmtotout year month TMDURATN TMATDT TMYLD maturity ITYPE;

year=year(MCALDT);
month=month(MCALDT);

where -0.1 < TMYLD < 0.1;

tmtotout = max(tmtotout,1);

*maturity = intck('years', MCALDT, TMATDT);

maturity = round(TMDURATN/365);

proc sort; by KYTREASNO KYCRSPID descending MCALDT;
run;

data temp; set temp;
last_day = intck('month', MCALDT, lag(MCALDT));

run;

proc sql; create table temp2 as select distinct
a.*
from temp a, crsp.TFZ_ISS b
where a.KYCRSPID=b.KYCRSPID and 1 le b.itype le 8;


proc sql;
create table temprr as select distinct
KYTREASNO, KYCRSPID, maturity , TMYLD, month, year, tmtotout
from temp2
where last_day = 1;

create table temprr2 as select distinct
year, month, maturity, KYTREASNO, KYCRSPID, maturity , TMYLD, month, year, tmtotout, tmtotout/sum(tmtotout) as w
from temprr group by year, month, maturity;


create table temprr3 as select distinct
year, month, maturity, sum(tmtotout) as tmtotout, sum(w*TMYLD) as yield
from temprr2 group by year, month, maturity;

proc download data = temprr3 out = yields;
run;


proc download data = crsp.TFZ_MTH_FT(where = (KYTREASNOX = 2000006 or KYTREASNOX = 2000009) keep = KYTREASNOX mcaldt TMYTM TMYTM)  out = yields_crsp;
run;

endrsubmit; 



proc sql;
create table short as select distinct
a.date, year, month, b.maturity, b.yield, tmtotout/sum(tmtotout) as w
from rsch.msi(where = (ex="USA")) a, yields b
where year(a.date)=year and month(a.date)=month and 3 le b.maturity le 7
group by year, month;

create table short as select distinct
date, sum(yield*w) as yield_short
from short group by year, month;

create table long as select distinct
a.date,  year, month, b.maturity, b.yield, tmtotout/sum(tmtotout) as w
from rsch.msi(where = (ex="USA")) a, yields b
where year(a.date)=year and month(a.date)=month and 10 le b.maturity le 35
group by year, month;

create table long as select distinct
date, sum(yield*w) as yield_long
from long group by year, month; 

create table crsp_yields as select distinct
a.date as date formay yymmddn8., b.TMYTM/100 as yield_short format 11.6, c.TMYTM/100 as yield_long format 11.6
from rsch.msi(where = (ex="USA")) a , yields_crsp(where = (KYTREASNOX = 2000006))  b, yields_crsp(where = (KYTREASNOX = 2000009)) c  where month(a.date)=month(b.mcaldt) = month(c.mcaldt)
and year(a.date)=year(b.mcaldt) = year(c.mcaldt);

proc sql; create table treasury_slope as select distinct
a.date, yield_short*365 as yield_short format 11.6 from rsch.msi(where = (ex="USA")) a left join short b on a.date=b.date;

create table treasury_slope as select distinct 
a.date, yield_short format 11.6, yield_long*365 as yield_long format 11.6
from  treasury_slope a left join long b on a.date=b.date;

*create table ind.treasury_slope as select distinct 
date, yield_long-yield_short as slope format 11.6, yield_short format 11.6, yield_long format 11.6
from  treasury_slope ;

create table all as select distinct
a.*, b.yield_long as long, b.yield_short as short
from treasury_slope a, crsp_yields b where month(a.date)=month(b.date) and year(a.date)=year(b.date);


data final; set treasury_slope; where date < MDY(11, 1, 1941); run;
proc append data = crsp_yields  base = final; run;

data final ; set final; slope = yield_long-yield_short; format slope 11.6; run; 

data ind.treasury_slope; set final; run;

%export(final);





