



%macro regression_predict(infile=&infile, xvar = &xvar , out = , lags = 18);


data p10;
set &infile;
xret = &xvar;
ind=1;
run;


proc reg data = P10 outest = out4 TABLEOUT noprint ADJRSQ; 
by ex ind ;  where ex not in ('INT'); 
model xret = level slope slope_bonds ; 
OUTPUT OUT = e residual = e;
run ; 


ods output parameterestimates=nw;
ods listing close;
proc model data=p10;
by ex;
  xret=intercept + beta_level*level + beta_slope*slope + beta_bonds*slope_bonds;
 fit xret / gmm kernel=(bart,%eval(&lags+1),0) vardef=n; run;
quit;
ods listing;


data nw1;
set nw;
where Parameter="beta_level" ;
run;

data nw2;
set nw;
where Parameter = "beta_slope";
run;



data nw3;
set nw;
where Parameter = "beta_bonds";
run;



proc sql; create table load as select distinct a.ex, a.ind, b.estimate as level, b.tvalue as tlevel,
c.estimate as slope, c.tvalue as tslope, e.estimate as slope_bonds, e.tvalue as tslope_bonds, _ADJRSQ_ as R2, sum(d.xret ne . ) as num
from out4(where = (_ADJRSQ_ ne .)) a, nw1 b, nw2 c , p10 d, nw3 e;


proc transpose data = load  out = out_temp(where = (_NAME_ ^= 'ind') drop = _LABEL_) ; where ex = 'USA'; run ; 

data &out;
set out_temp;
rename COL1=&xvar;run;

* house cleaning ; 
proc delete data = xr txr a4f ta4f u out4 load out0 a1f ta1f tload e ee n R2 P10 xret out_temp out_temp2 nw nw1 nw2; run ; 

%mend;


