



%macro regression_slope(infile=&infile, xvar = &xvar , out = , lags = 18);


data p10;
set &infile;
xret = slope;
ind=1;
ex="USA";
drop beta;
run;


proc reg data = P10 outest = out4 TABLEOUT noprint ADJRSQ; 
by ex ind ;  
model xret = slope_bonds  ; 
OUTPUT OUT = e residual = e;
run ; 


ods output parameterestimates=nw;
ods listing close;
proc model data=p10;
by ex;
  xret=intercept + beta*slope_bonds;
 fit xret / gmm kernel=(bart,%eval(&lags+1),0) vardef=n; run;
quit;
ods listing;


data nw1;
set nw;
where Parameter="beta" ;
run;

proc sql; create table load as select distinct a.ex, a.ind, b.estimate as beta, b.tvalue as t, _ADJRSQ_ as R2, sum(d.xret ne . ) as num
from out4(where = (_ADJRSQ_ ne .)) a, nw1 b, p10 d;


proc transpose data = load  out = out_temp(where = (_NAME_ ^= 'ind') drop = _LABEL_) ; where ex = 'USA'; run ; 

data &out;
set out_temp;
rename COL1=&out;
run;

* house cleaning ; 
proc delete data = xr txr a4f ta4f u out4 load out0 a1f ta1f tload e ee n R2 P10 xret out_temp out_temp2 nw nw1 nw2; run ; 

%mend;


