
clear all

if regexm(`"`c(pwd)'"',`"Elazarus"') {
	cd "/Users/Elazarus/Dropbox (Personal)/Work/Research/Niels/DurationBasedAP/Data and programs/Stata/Data/LTG"
}
else {
	cd "~/Dropbox/DurationBasedAP/Final Version/Data and programs/Input/Stata/Data/LTG"
}







clear all

use dividends_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  replace ctitle(DividendGrowth)  label auto(2) excel tex(fragment) nocons




clear all

use earnings_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)
egen idn = group(id)
gen yr = year(refresh_date)
format yr %ty
tsset idn yr

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  append ctitle(EarningsGrowth)  label auto(2) excel tex(fragment) nocons





















use earnings_realized, clear
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm

levelsof y_m, local(ymlist)

egen id = concat(name ind), punct(-)
local j = 1

foreach rhvar of varlist bm op low_inv low_beta pay {
	gen `rhvar'_pct2 = .
	foreach ymval of local ymlist {
		
		qui sum `rhvar' if y_m==`ymval'
		local nqn = r(N)+1
		xtile `rhvar'_`j' = `rhvar' if y_m==`ymval', nquantiles(`nqn')
		replace `rhvar'_pct2 = `rhvar'_`j' if y_m==`ymval'
		
		local j = `j'+1
	}
}

foreach abs_spec in "noabsorb" "absorb(y_m)" {
	foreach year_min of numlist 1963 1953 {
		di _newline _newline "Absorb specification: `abs_spec'" _newline "Sample start: `year_min'" _newline
		reghdfe growth2 bm op low_inv low_beta pay  if year(refresh_date) >= `year_min' , cluster(id y_m) `abs_spec'
		reghdfe growth2 bm_pct2 op_pct2 low_inv_pct2 low_beta_pct2 pay_pct2  if year(refresh_date) >= `year_min' , cluster(id y_m) `abs_spec'
		foreach xvar of varlist bm op low_inv low_beta pay {
			reghdfe growth2 `xvar'  if year(refresh_date) >= `year_min' , cluster(id y_m) `abs_spec'
		}
	}
}

/*
reghdfe growth2 bm op low_inv low_beta pay  if year(refresh_date) >= 1963 , cluster(id y_m) noabsorb
reghdfe growth2 bm op low_inv low_beta pay  if year(refresh_date) >= 1963 , cluster(id y_m) absorb(y_m)
reghdfe growth2 bm op low_inv low_beta pay , cluster(id y_m) noabsorb
reghdfe growth2 bm op low_inv low_beta pay , cluster(id y_m) absorb(y_m)

reghdfe growth2 bm , cluster(id y_m) absorb(y_m)
reghdfe growth2 op , cluster(id y_m) absorb(y_m)
reghdfe growth2 low_inv , cluster(id y_m) absorb(y_m)
reghdfe growth2 low_beta , cluster(id y_m) absorb(y_m)
reghdfe growth2 pay , cluster(id y_m) absorb(y_m)

reghdfe growth2 bm , cluster(id y_m) noabsorb
reghdfe growth2 op , cluster(id y_m) noabsorb
reghdfe growth2 low_inv , cluster(id y_m) noabsorb
reghdfe growth2 low_beta , cluster(id y_m) noabsorb
reghdfe growth2 pay , cluster(id y_m) noabsorb
*/




preserve
collapse (mean) growth2 bm op low_inv low_beta pay bm_pct2 op_pct2 low_inv_pct2 low_beta_pct2 pay_pct2, by(id)
reg growth2 bm op low_inv low_beta pay , robust
restore
preserve
collapse (mean) growth2 growth3 bm op low_inv low_beta pay bm_pct2 op_pct2 low_inv_pct2 low_beta_pct2 pay_pct2 if year(refresh_date) >= 1963 , by(id)
reg growth2 bm op low_inv low_beta pay , robust
reg growth3 bm op low_inv low_beta pay , robust
restore


clear all

use dividends_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  replace ctitle(DividendGrowth)  label auto(2) excel tex(fragment) nocons




clear all

use earnings_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)
egen idn = group(id)
gen yr = year(refresh_date)
format yr %ty
tsset idn yr

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  append ctitle(EarningsGrowth)  label auto(2) excel tex(fragment) nocons


preserve
mi set wide
mi register imputed div1 growth2 growth3
mi impute mvn div1 growth2 growth3 = div2 low_beta bm op low_inv pay me i.yr, add(1)
restore

preserve
collapse (mean) growth2 growth3 bm op low_inv low_beta pay if year(refresh_date) >= 1963, by(id)
reg growth2 bm op low_inv low_beta pay , robust
reg growth3 bm op low_inv low_beta pay , robust
restore

reghdfe growth3 bm if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
reghdfe growth3 op if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
reghdfe growth3 low_inv if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
reghdfe growth3 low_beta if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
reghdfe growth3 pay if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)

gen g3pct = .
local ind = 1
levelsof y_m, local(ymlist)
foreach ymval of local ymlist {
	pctile pct3_`ind' = growth3 if y_m == `ymval', nquantiles(100)
	xtile g3pct_`ind' = growth3 if y_m == `ymval', cutpoints(pct3_`ind')
	replace g3pct = g3pct_`ind' if y_m == `ymval'
	drop pct3_`ind' g3pct_`ind'
}

gen g2pct = .
local ind = 1
levelsof y_m, local(ymlist)
foreach ymval of local ymlist {
	pctile pct2_`ind' = growth2 if y_m == `ymval', nquantiles(100)
	xtile g2pct_`ind' = growth2 if y_m == `ymval', cutpoints(pct2_`ind')
	replace g2pct = g2pct_`ind' if y_m == `ymval'
	drop pct2_`ind' g2pct_`ind'
}

